<< problem 174 - Counting the number of "hollow" square laminae ... | Consecutive positive divisors - problem 179 >> |
Problem 178: Step Numbers
(see projecteuler.net/problem=178)
Consider the number 45656.
It can be seen that each pair of consecutive digits of 45656 has a difference of one.
A number for which every pair of consecutive digits has a difference of one is called a step number.
A pandigital number contains every decimal digit from 0 to 9 at least once.
How many pandigital step numbers less than 10^40 are there?
My Algorithm
And again: it's time for Dynamic Programming ...
My search
function has three parameters:
1. a mask where bit x is set if any of the digits in front of the current digit was x.
2. the current digit
3. how many digits still have to be processed
A number is pandigital if the all bits 0..9 are set (AllDigits = (1 << 10) - 1
which is 1023).
If the current digit is bigger than 0, then the next can be "a step down".
If the current digit is smaller than 9, then the next can be "a step up".
Of course, this algorithm would be far too slow, but the algorithm can heavily memoize results.
The function's parameters are merged into a single unique ID and stored in a cache
(with 1024*40*10 = 409600 entries, which requires about 3 MByte RAM).
Modifications by HackerRank
They want you to compute the result for n < 10^{10^4}. I can't figure out whether their input is always a power-of-ten or not.
The result will easily be too large for C++'s 64 bit integers anyway.
Note
If the first digit is between 1 and 4 (inclusive), then for every solution there is a "mirrored" version, where each digit b_i = 9 - a_i.
For example, 10123456789 is a solution and therefore 89876543210 is a solution, too.
How does it help ? Well, you can compute all solutions starting with 1..4, multiply that number by 2 and add all solutions starting with 9.
Interactive test
You can submit your own input to my program and it will be instantly processed at my server:
This is equivalent toecho 11 | ./178
Output:
Note: the original problem's input 40
cannot be entered
because just copying results is a soft skill reserved for idiots.
(this interactive test is still under development, computations will be aborted after one second)
My code
… was written in C++ and can be compiled with G++, Clang++, Visual C++. You can download it, too. Or just jump to my GitHub repository.
#include <iostream>
#include <vector>
// initial state: no digits used, all bits are zero
const unsigned int NoDigits = 0;
// all ten digits used => all ten bits set
const unsigned int AllDigits = (1 << 10) - 1; // = 1023
// analyze all numbers with up to 10^40
const unsigned int MaxDigits = 40;
// count pandigital step number where bits in "mask" are set according to the first digits
// and the current digit is "currentDigit" with "numDigitsLeft" digits to go
unsigned long long search(unsigned int mask, unsigned int currentDigit, unsigned int numDigitsLeft)
{
// update mask, "use digit"
mask |= 1 << currentDigit;
// arrived at last digit ?
if (numDigitsLeft == 1)
{
// all ten bits set ? => pandigital
if (mask == AllDigits)
return 1; // yes, a solution
// not pandigital, no valid solution
return 0;
}
// memoize
unsigned int hash = mask * MaxDigits * 10 + (numDigitsLeft - 1) * 10 + currentDigit;
static std::vector<unsigned long long> cache(1024 * 10 * MaxDigits, 0);
// result already known ?
if (cache[hash] != 0)
return cache[hash];
unsigned long long result = 0;
// next digit is smaller
if (currentDigit > 0)
result += search(mask, currentDigit - 1, numDigitsLeft - 1);
// next digit is bigger
if (currentDigit < 9)
result += search(mask, currentDigit + 1, numDigitsLeft - 1);
cache[hash] = result;
return result;
}
int main()
{
// maxDigits is the actual number of digits
// MaxDigits is the highest allowed value for maxDigits
// I know, it's confusing ...
unsigned int maxDigits = 40;
std::cin >> maxDigits;
// note: input syntax differs from Hackerrank !
unsigned long long result = 0;
// for each number of digits ...
for (unsigned int numDigits = 1; numDigits <= maxDigits; numDigits++)
{
// ... the first one must be 1..9 (and never zero !)
for (unsigned int digit = 1; digit <= 9; digit++)
result += search(NoDigits, digit, numDigits);
// a little bit faster:
//result += 2 * search(NoDigits, 1, numDigits);
//result += 2 * search(NoDigits, 2, numDigits);
//result += 2 * search(NoDigits, 3, numDigits);
//result += 2 * search(NoDigits, 4, numDigits);
//result += search(NoDigits, 9, numDigits);
}
std::cout << result << std::endl;
return 0;
}
This solution contains 11 empty lines, 25 comments and 2 preprocessor commands.
Benchmark
The correct solution to the original Project Euler problem was found in less than 0.01 seconds on an Intel® Core™ i7-2600K CPU @ 3.40GHz.
Peak memory usage was about 5 MByte.
(compiled for x86_64 / Linux, GCC flags: -O3 -march=native -fno-exceptions -fno-rtti -std=gnu++11 -DORIGINAL
)
See here for a comparison of all solutions.
Note: interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without -DORIGINAL
.
Changelog
June 28, 2017 submitted solution
June 28, 2017 added comments
Hackerrank
see https://www.hackerrank.com/contests/projecteuler/challenges/euler178
My code solves 2 out of 25 test cases (score: 4.17%)
I failed 23 test cases due to wrong answers and 0 because of timeouts
Difficulty
Project Euler ranks this problem at 55% (out of 100%).
Hackerrank describes this problem as medium.
Note:
Hackerrank has strict execution time limits (typically 2 seconds for C++ code) and often a much wider input range than the original problem.
In my opinion, Hackerrank's modified problems are usually a lot harder to solve. As a rule thumb: brute-force is rarely an option.
Links
projecteuler.net/thread=178 - the best forum on the subject (note: you have to submit the correct solution first)
Code in various languages:
Python github.com/frrad/project-euler/blob/master/python/Problem178.py (written by Frederick Robinson)
Python github.com/nayuki/Project-Euler-solutions/blob/master/python/p178.py (written by Nayuki)
Python github.com/smacke/project-euler/blob/master/python/178.py (written by Stephen Macke)
Python github.com/steve98654/ProjectEuler/blob/master/178.py
C++ github.com/Meng-Gen/ProjectEuler/blob/master/178.cc (written by Meng-Gen Tsai)
C github.com/LaurentMazare/ProjectEuler/blob/master/e178.c (written by Laurent Mazare)
Java github.com/HaochenLiu/My-Project-Euler/blob/master/178.java (written by Haochen Liu)
Java github.com/nayuki/Project-Euler-solutions/blob/master/java/p178.java (written by Nayuki)
Java github.com/thrap/project-euler/blob/master/src/Java/Problem178.java (written by Magnus Solheim Thrap)
Mathematica github.com/nayuki/Project-Euler-solutions/blob/master/mathematica/p178.mathematica (written by Nayuki)
Perl github.com/shlomif/project-euler/blob/master/project-euler/178/euler-178-v1.pl (written by Shlomi Fish)
Those links are just an unordered selection of source code I found with a semi-automatic search script on Google/Bing/GitHub/whatever.
You will probably stumble upon better solutions when searching on your own.
Maybe not all linked resources produce the correct result and/or exceed time/memory limits.
Heatmap
Please click on a problem's number to open my solution to that problem:
green | solutions solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too | |
yellow | solutions score less than 100% at Hackerrank (but still solve the original problem easily) | |
gray | problems are already solved but I haven't published my solution yet | |
blue | solutions are relevant for Project Euler only: there wasn't a Hackerrank version of it (at the time I solved it) or it differed too much | |
orange | problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte | |
red | problems are not solved yet but I wrote a simulation to approximate the result or verified at least the given example - usually I sketched a few ideas, too | |
black | problems are solved but access to the solution is blocked for a few days until the next problem is published | |
[new] | the flashing problem is the one I solved most recently |
I stopped working on Project Euler problems around the time they released 617.
1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |
26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |
51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |
76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |
101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |
126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |
151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |
176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |
201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |
226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |
251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |
276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |
301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |
326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |
351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |
376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |
401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |
426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |
451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |
476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |
501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |
526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |
551 | 552 | 553 | 554 | 555 | 556 | 557 | 558 | 559 | 560 | 561 | 562 | 563 | 564 | 565 | 566 | 567 | 568 | 569 | 570 | 571 | 572 | 573 | 574 | 575 |
576 | 577 | 578 | 579 | 580 | 581 | 582 | 583 | 584 | 585 | 586 | 587 | 588 | 589 | 590 | 591 | 592 | 593 | 594 | 595 | 596 | 597 | 598 | 599 | 600 |
601 | 602 | 603 | 604 | 605 | 606 | 607 | 608 | 609 | 610 | 611 | 612 | 613 | 614 | 615 | 616 | 617 | 618 | 619 | 620 | 621 | 622 | 623 | 624 | 625 |
626 | 627 | 628 | 629 | 630 | 631 | 632 | 633 | 634 | 635 | 636 | 637 | 638 | 639 | 640 | 641 | 642 | 643 | 644 | 645 | 646 | 647 | 648 | 649 | 650 |
651 | 652 | 653 | 654 | 655 | 656 | 657 | 658 | 659 | 660 | 661 | 662 | 663 | 664 | 665 | 666 | 667 | 668 | 669 | 670 | 671 | 672 | 673 | 674 | 675 |
676 | 677 | 678 | 679 | 680 | 681 | 682 | 683 | 684 | 685 | 686 | 687 | 688 | 689 | 690 | 691 | 692 | 693 | 694 | 695 | 696 |
I scored 13526 points (out of 15700 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.
My username at Project Euler is stephanbrumme while it's stbrumme at Hackerrank.
Look at my progress and performance pages to get more details.
Copyright
I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.
All of my solutions can be used for any purpose and I am in no way liable for any damages caused.
You can even remove my name and claim it's yours. But then you shall burn in hell.
The problems and most of the problems' images were created by Project Euler.
Thanks for all their endless effort !!!
<< problem 174 - Counting the number of "hollow" square laminae ... | Consecutive positive divisors - problem 179 >> |